#include <gtk/gtk.h>
#include <mysql/mysql.h>
#include <stdio.h>
#include "main.h"

int export_to_csf(const gchar *name);
int export_to_html(const gchar *name);

void export_file_selector(){
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    GtkTreeModel *model = GTK_TREE_MODEL(main_win.index.liststore);
    GtkWidget *fileselector;
    GtkWidget *option_menu, *menu_shell, *hbox, *ali;
    int value, close =0;
    char *tempstr;
    
    /* check if there is a valid table to export */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));
    if(!gtk_tree_selection_get_selected(selection, &model, &iter))
	{
	    error_dialog("You need to select a sub-category before you can export it");
	    return;
	}
    gtk_tree_model_get(model, &iter,1, &value, -1);
    if(value != 1)
	{
	    error_dialog("You need to select a sub-category before you can export it");
	    return;
	}

    fileselector = gtk_file_selection_new("Export to ...");
    tempstr = g_strdup_printf("%s/", g_getenv("HOME"));
    gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselector),tempstr);
    g_free(tempstr);
    
    /* make type selector */
    option_menu = gtk_option_menu_new();
    menu_shell = gtk_menu_new();
    gtk_option_menu_set_menu(GTK_OPTION_MENU(option_menu), menu_shell);
    gtk_menu_shell_append (GTK_MENU_SHELL (menu_shell), gtk_menu_item_new_with_label("Comma Seperated File"));  
    gtk_menu_shell_append (GTK_MENU_SHELL (menu_shell), gtk_menu_item_new_with_label("HTML"));      
    gtk_option_menu_set_history(GTK_OPTION_MENU(option_menu), 0);
    
    hbox = gtk_hbox_new(FALSE, 6);
    ali = gtk_alignment_new(1, 0.5, 0.5,0.5);
    gtk_container_add(GTK_CONTAINER(ali), gtk_label_new("File Type:"));
    
    gtk_box_pack_start(GTK_BOX(GTK_FILE_SELECTION(fileselector)->main_vbox), hbox, FALSE, TRUE, 6);
    gtk_box_pack_end(GTK_BOX(hbox), option_menu, FALSE, TRUE, 6);
    gtk_box_pack_end(GTK_BOX(hbox), ali, FALSE, TRUE, 6);

    gtk_widget_show_all(hbox);
    
    
    while(!close){
	switch(gtk_dialog_run(GTK_DIALOG(fileselector))){
	case GTK_RESPONSE_OK:
	    /* check if selected file is a directory */
	    if(g_file_test(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselector)), G_FILE_TEST_IS_DIR))
		{
		const gchar *string = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselector));
		gchar *result = g_strconcat(string, "/", NULL);
		gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselector),result);
		g_free(result);
		close = 0;		
		break;
		}
	    if(g_file_test(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselector)), G_FILE_TEST_EXISTS))
		{
		GtkWidget *dialog;
		dialog = gtk_message_dialog_new(GTK_WINDOW(fileselector), GTK_DIALOG_MODAL|GTK_DIALOG_DESTROY_WITH_PARENT, 
						GTK_MESSAGE_WARNING, GTK_BUTTONS_YES_NO, "File Exsits?\nDo you want to continue?");
		switch(gtk_dialog_run(GTK_DIALOG(dialog))){
		case GTK_RESPONSE_YES:
				value = gtk_option_menu_get_history(GTK_OPTION_MENU(option_menu));
		    if(value == 0){
			if(export_to_csf(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselector)))) close = 1;
			}
		    else if(value == 1){
			if(export_to_html(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselector)))) close = 1;
		    }
		    else close = 0;	    
		    break;
				
		default:
		    close = 0;
		    break;
		    }
		gtk_widget_destroy(dialog);
		}
		else{
		value = gtk_option_menu_get_history(GTK_OPTION_MENU(option_menu));
		    if(value == 0){
			if(export_to_csf(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselector)))) close = 1;
			}
		    else if(value == 1){
			if(export_to_html(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselector)))) close = 1;
		    }
	    }
	    break;
	case GTK_RESPONSE_CANCEL:
	    close = 1;
	default:
	    close = 1;
	    break;
	}
    }	
    gtk_widget_destroy(fileselector);
}    

int export_to_csf(const gchar *name){
    FILE *fp;
    gchar *tempstr;
    GtkTreeModel *model = GTK_TREE_MODEL(main_win.index.treestore);
    GtkTreeIter iter;
    int i, value;
    
    fp = fopen(name, "w");
    if(fp == NULL){
	error_dialog("Failed to open the file for writing.");
	return 0;
    }
    
/*    
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));
    gtk_tree_selection_get_selected(selection, &model, &iter);
    gtk_tree_model_get(model, &iter,0, &tempstr, -1);
*/
    model = GTK_TREE_MODEL(main_win.table.liststore);
/*	for(i=1; i< ncol; i++)
	    {
		fprintf(fp, "%s;", gtk_tree_view_column_get_title(main_win.table.columns[i]));
	    }
	    fprintf(fp, "\n");
*/	    
    if(gtk_tree_model_get_iter_first(model, &iter) != FALSE)
    do	{
	for(i=1; i< ncol; i++)
	    {
		if(main_win.table.types[i] == G_TYPE_BOOLEAN){
			gtk_tree_model_get(model, &iter, i, &value, -1);
			if(value == 1)
			    {
			    if(i == (ncol-1)) fprintf(fp, "\"TRUE\"\n");
			    else fprintf(fp, "\"TRUE\",");
			    }
			else{
			    if(i == (ncol-1)) fprintf(fp, "\"FALSE\"\n");
			    else fprintf(fp, "\"FALSE\",");
			    }
		    }
		else if(main_win.table.types[i] == G_TYPE_INT){
		    gtk_tree_model_get(model, &iter, i, &value, -1);
		    if(i == (ncol-1)) fprintf(fp, "\"%i\"\n", value);
		    else
			fprintf(fp, "\"%i\",", value);
		    }
		else{
		gtk_tree_model_get(model, &iter, i, &tempstr, -1);
		if(i == (ncol-1)) fprintf(fp, "\"%s\"\n", tempstr);
		else
		fprintf(fp, "\"%s\",", tempstr);
		}
	    }
//	fprintf(fp, "\n");
	}while(gtk_tree_model_iter_next(model, &iter));
    fclose(fp);
    return 1;
}

int export_to_html(const gchar *name){
    FILE *fp;
    gchar *tempstr;
    GtkTreeModel *model = GTK_TREE_MODEL(main_win.index.treestore);
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    int i, value;
    
    fp = fopen(name, "w");
    if(fp == NULL){
	error_dialog("Failed to open the file for writing.");
	return 0;
    }
    
    
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));
    gtk_tree_selection_get_selected(selection, &model, &iter);
    gtk_tree_model_get(model, &iter,0, &tempstr, -1);

    model = GTK_TREE_MODEL(main_win.table.liststore);
    fprintf(fp, "<HTML><TITLE>%s</TITLE>\n", tempstr);
    fprintf(fp, "<BODY><H2>%s</H2><TABLE border=\"1px\">\n",tempstr);
    fprintf(fp, "<TR>\n");
	for(i=1; i< ncol; i++)
	    {
		
		fprintf(fp, "<TD><B>%s</B></TD>\n", gtk_tree_view_column_get_title(main_win.table.columns[i]));
	    }
	fprintf(fp, "</TR>\n");
    if(gtk_tree_model_get_iter_first(model, &iter) != FALSE)
    do	{
	fprintf(fp, "<TR>\n");
	for(i=1; i< ncol; i++)
	    {
		if(main_win.table.types[i] == G_TYPE_BOOLEAN)
		    {
		    gtk_tree_model_get(model, &iter, i, &value, -1);
		    if(value == 1)fprintf(fp, "<TD>TRUE</TD>\n");
		    else fprintf(fp, "<TD>FALSE</TD>\n");
		    
		    }
		else if(main_win.table.types[i] == G_TYPE_INT)
		    {
		    gtk_tree_model_get(model, &iter, i, &value, -1);
		    fprintf(fp, "<TD>%i</TD>\n", value);
		    
		    }
	
		else{
		    gtk_tree_model_get(model, &iter, i, &tempstr, -1);
		    fprintf(fp, "<TD>%s</TD>\n", tempstr);
		    }
	    }
	fprintf(fp, "</TR>\n");
	}while(gtk_tree_model_iter_next(model, &iter));
    fprintf(fp, "</TABLE></BODY></HTML>");
    fclose(fp);
    return 1;
}
