#include <gtk/gtk.h>
#include <mysql/mysql.h>
#include <stdlib.h>
#include "main.h"

windows main_win;
info main_info;
GtkWidget *qs_menu;
GtkWidget *qs_option, *sentry;
GtkWidget **qs_sel;
void about_box();



/****************************************
 * The menu's @ the top 		*
 ***************************************/

static GtkItemFactoryEntry menu_items[] =
{
  { "/_File",		 	NULL,	       	0,			0, "<Branch>" 		},
  { "/File/tearoff1",	 	NULL,	       	0,	      		0, "<Tearoff>" 		},
  { "/File/_Connect",	 	"<control>C", 	connect_to_dbase,	0},
  { "/File/_Disconnect", 	"<control>D", 	quit_connection,	0},
//  { "/File/_Reconnect",	 	"<control>R", 	0,	      		0},
  { "/File/sep1",	 	NULL,	       	0,	      		0, 	"<Separator>" 	},
  { "/File/_Export table",	"<control>E",	export_file_selector,	0},
  { "/File/_Import table",	"<control>I", 	import_file_selector,	0},
  { "/File/sep2",	 	NULL,	       	0,	      		0, 	"<Separator>" 	},
  { "/File/_Quit",		"<control>Q", 	quit_program, 		0, 	"<StockItem>", 	GTK_STOCK_QUIT},

  { "/_Database", 		NULL,	 	0,			0, "<Branch>"},
  { "/Database/tearoff1",	NULL,		0,			0, "<Tearoff>"},
  {"/Database/_Category", 	NULL, 		0, 			0, "<Branch>"},
  {"/Database/Category/_New",	"",		add_a_category,		0, "<StockItem>", GTK_STOCK_ADD},
  {"/Database/Category/_Edit",	"",		edit_category_title,		0,},  
  {"/Database/Category/_Delete","",		delete_a_category,	0, "<StockItem>", GTK_STOCK_REMOVE},
  {"/Database/_Sub category", 	NULL, 		0, 			0, "<Branch>"},
  {"/Database/Sub category/_New","",		add_sub_category,	0, "<StockItem>", GTK_STOCK_ADD},
  {"/Database/Sub category/_Edit","",		edit_sub_category,	0},
  {"/Database/Sub category/_Delete","",	delete_sub_category,	0, "<StockItem>", GTK_STOCK_REMOVE},
  {"/Database/Sub category/sep3", NULL, 	0, 			0, 	"<Separator>"},
  {"/Database/Sub category/_Empty","",	empty_sub_category,	0},
  
  {"/Database/_Item", 		NULL, 		0, 			0, "<Branch>"},
  {"/Database/Item/_New",	"",		add_a_item,		0, "<StockItem>", GTK_STOCK_NEW},
  {"/Database/Item/_Delete",	"",		delete_item,		0, "<StockItem>", GTK_STOCK_DELETE},
 
  { "/Database/_Preferences",	NULL, 	pref_screen, 0, "<StockItem>", GTK_STOCK_PREFERENCES},


  { "/_Help",		 NULL,	       0,		      0, "<LastBranch>" },
  { "/Help/_About",	 NULL,	       about_box,	      0},
};

static int nmenu_items = sizeof (menu_items) / sizeof (menu_items[0]);

/****************************************
 * The index mouse menu 		*
 ***************************************/

static GtkItemFactoryEntry mouse_menu_items[] =
{
  {"/New Category",		"",		add_a_category,		0, "<StockItem>", GTK_STOCK_ADD},
  {"/Edit Category",		"",		edit_category_title,	0},
  {"/Delete Category",		"",		delete_a_category,	0, "<StockItem>", GTK_STOCK_REMOVE},
  { "/sep",	 		NULL,	       	0,	      		0, "<Separator>" 	},
  {"/New Sub-Category",		"",		add_sub_category,	0, "<StockItem>", GTK_STOCK_ADD},
  {"/Edit Sub-Category",	"",		edit_sub_category,	0},
  {"/Delete Sub-Category",	"",		delete_sub_category,	0, "<StockItem>", GTK_STOCK_REMOVE},

};

static int nmouse_menu_items = sizeof (mouse_menu_items) / sizeof (mouse_menu_items[0]);

/****************************************
 * The table mouse menu 		*
 ***************************************/

static GtkItemFactoryEntry mouse_menu_table[] =
{
  {"/_New",	"",		add_a_item,	0, "<StockItem>", GTK_STOCK_NEW},
  {"/_Delete",	"",		delete_item,	0, "<StockItem>", GTK_STOCK_DELETE},
};

static int nmouse_menu_table = sizeof (mouse_menu_table) / sizeof (mouse_menu_table[0]);







void create_main_window(){
    GtkCellRenderer *renderer;
    GtkTreeSelection *selection;
    main_win.window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    
    
    gtk_window_set_icon(GTK_WINDOW(main_win.window), gdk_pixbuf_new_from_file(PIXMAP_PATH"/inventory.png", NULL));
    gtk_window_set_title(GTK_WINDOW(main_win.window), "Inventory");

    /* doing this here causes less flash as the window is drawn, then moved */

    if(main_info.save_posize == 1) {
        gtk_window_set_default_size(GTK_WINDOW(main_win.window),
            main_info.width, main_info.height);
        gtk_widget_set_uposition(GTK_WIDGET(main_win.window),
            main_info.x, main_info.y);
    }


    /* add an accel group (later to attach to window ) */
    main_win.accel_group = gtk_accel_group_new ();
    
    main_win.vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(main_win.window), main_win.vbox);
    

    /* here we go with the drop down menu's dont we love the item_factory :) */
      main_win.item_factory = gtk_item_factory_new (GTK_TYPE_MENU_BAR, "<main>", main_win.accel_group);
      g_object_set_data_full (G_OBJECT (main_win.window), "<main>",
			      main_win.item_factory, (GDestroyNotify) g_object_unref);
      gtk_item_factory_create_items (main_win.item_factory, nmenu_items, menu_items, NULL);
	/* add it */
	gtk_box_pack_start(GTK_BOX(main_win.vbox), gtk_item_factory_get_widget(main_win.item_factory, "<main>"), FALSE, TRUE, 0);

    /* set the disconnect inactive */
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/File/Disconnect"), FALSE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/File/Import table"), FALSE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/File/Export table"), FALSE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category"), FALSE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category"), FALSE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item"), FALSE);    


    /* add the toolbar */
    main_win.toolbar = gtk_toolbar_new();
    gtk_widget_set_sensitive(GTK_WIDGET(main_win.toolbar), FALSE);
//    gtk_toolbar_append_space(GTK_TOOLBAR(main_win.toolbar));


    qs_option = gtk_option_menu_new();
    qs_menu = gtk_menu_new();
    gtk_widget_set_usize(qs_option, 120 , -1);
    gtk_widget_set_usize(qs_menu, 100 , -1);
    gtk_option_menu_set_menu(GTK_OPTION_MENU(qs_option), qs_menu);
    gtk_toolbar_append_widget(GTK_TOOLBAR(main_win.toolbar),  qs_option, "quick search", "");

    sentry = gtk_entry_new_with_max_length(255);
    gtk_entry_set_text(GTK_ENTRY(sentry), "Quick Search");
    gtk_toolbar_append_widget(GTK_TOOLBAR(main_win.toolbar),  sentry, "quick search", "");
    g_signal_connect(G_OBJECT(sentry), "activate", G_CALLBACK(do_quick_search), NULL);

    gtk_toolbar_append_space(GTK_TOOLBAR(main_win.toolbar));
    gtk_toolbar_insert_stock(GTK_TOOLBAR(main_win.toolbar), GTK_STOCK_NEW, "Add an item to the table", "", G_CALLBACK(add_a_item), NULL, -1);
    gtk_toolbar_insert_stock(GTK_TOOLBAR(main_win.toolbar), GTK_STOCK_DELETE, "Delete the selected item", "", G_CALLBACK(delete_item), NULL, -1);
    gtk_toolbar_append_item(GTK_TOOLBAR(main_win.toolbar),"View/Edit", "Edit/view the selected item", "", NULL, G_CALLBACK(edit_view_a_item), NULL);

    
    gtk_toolbar_set_style(GTK_TOOLBAR(main_win.toolbar), GTK_TOOLBAR_BOTH_HORIZ);
    gtk_toolbar_set_icon_size(GTK_TOOLBAR(main_win.toolbar), GTK_ICON_SIZE_SMALL_TOOLBAR);    
    
    
    /* add the toolbar to the vbox */
    gtk_box_pack_start(GTK_BOX(main_win.vbox), main_win.toolbar, FALSE, TRUE,0);    
    

    /* add the paned window that holds the 2 tree's */
    main_win.hpaned = gtk_hpaned_new();
    /* add hpaned  to the main window */
    gtk_box_pack_start(GTK_BOX(main_win.vbox), main_win.hpaned, TRUE, TRUE,0);    

    /* add the tree that display's the index tree */
    main_win.index.viewport = gtk_scrolled_window_new(NULL, NULL);
    gtk_paned_add1 (GTK_PANED(main_win.hpaned), main_win.index.viewport);    
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(main_win.index.viewport), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    
    main_win.index.treestore = gtk_tree_store_new(2,G_TYPE_STRING, G_TYPE_INT);
    main_win.index.model = GTK_TREE_MODEL(main_win.index.treestore);
    main_win.index.treeview = gtk_tree_view_new_with_model(main_win.index.model);
    
    /* column for the index */
    renderer = gtk_cell_renderer_text_new ();
    gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (main_win.index.treeview),-1, "Index", renderer, "text",0, NULL);
    /* add it to the scrolled window */
    gtk_container_add(GTK_CONTAINER(main_win.index.viewport), GTK_WIDGET(main_win.index.treeview));
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));												    

    gtk_paned_set_position(GTK_PANED(main_win.hpaned), 200);


    main_win.index.item_factory = gtk_item_factory_new (GTK_TYPE_MENU, "<popup>", main_win.accel_group);
    g_object_set_data_full (G_OBJECT (main_win.window), "<popup>",
			      main_win.index.item_factory, (GDestroyNotify) g_object_unref);
    gtk_item_factory_create_items (main_win.index.item_factory, nmouse_menu_items, mouse_menu_items, NULL);
	/* add it */
    main_win.index.menu = gtk_item_factory_get_widget(main_win.index.item_factory, "<popup>");


   /* connect our handler which will popup the menu */
    g_signal_connect(G_OBJECT(selection), "changed", G_CALLBACK(index_changed_test), NULL);    
    g_signal_connect(GTK_OBJECT (main_win.index.treeview), "button_release_event", G_CALLBACK (my_popup_handler), GTK_OBJECT (main_win.index.menu));
    g_signal_connect(G_OBJECT(main_win.index.treeview), "row-activated", G_CALLBACK(handle_index_double_click_signal), NULL);
    
    /* add the tree that display's the finall dbase */
    main_win.table.viewport = gtk_scrolled_window_new(NULL, NULL);    
    gtk_paned_add2 (GTK_PANED(main_win.hpaned), main_win.table.viewport);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(main_win.table.viewport), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    /* set number of colums to NULL */
    main_win.table.columns = g_malloc(sizeof(GtkTreeViewColumn));      
    main_win.table.columns[0] = NULL;   



    /* create a liststore (for now only max 11 user defined fields, first field is an ID) */ 
    /* if filling in table, the "type" can be set to f.e. boolean */
    main_win.table.liststore = gtk_list_store_new(13, G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, 
						      G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING,
						      G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING,
						      G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_BOOLEAN);

    main_win.table.model = GTK_TREE_MODEL(main_win.table.liststore);
    main_win.table.treeview = gtk_tree_view_new_with_model(main_win.table.model);
    gtk_container_add(GTK_CONTAINER(main_win.table.viewport), GTK_WIDGET(main_win.table.treeview));

    /* add table right mouse click */
    main_win.table.item_factory = gtk_item_factory_new (GTK_TYPE_MENU, "<tablepop>", main_win.accel_group);
    g_object_set_data_full (G_OBJECT (main_win.window), "<tablepop>",
			      main_win.table.item_factory, (GDestroyNotify) g_object_unref);
    gtk_item_factory_create_items (main_win.table.item_factory, nmouse_menu_table, mouse_menu_table, NULL);
	/* add it */
    main_win.table.menu = gtk_item_factory_get_widget(main_win.table.item_factory, "<tablepop>");

   /* connect our handler which will popup the menu */
    /* this one should becalled before the default */
    g_signal_connect (GTK_OBJECT (main_win.table.treeview), "button_release_event", G_CALLBACK (table_popup_handler), GTK_OBJECT (main_win.table.menu));
    /*how to block the edit command .. so this goes BEFORE the edit */

	/* if this is enabled fix the pop-up handler and anything else that tries to get the selection */    
    gtk_tree_selection_set_mode(gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.table.treeview)), GTK_SELECTION_MULTIPLE);
	/* add tree_view settings */

	gtk_tree_view_set_rules_hint(GTK_TREE_VIEW(main_win.table.treeview), TRUE);
	gtk_tree_view_set_rules_hint(GTK_TREE_VIEW(main_win.index.treeview), TRUE);
	

    /* add a status bar and a progress box*/
    main_win.statusbar = gtk_statusbar_new();
    main_win.progress = gtk_progress_bar_new();
    main_win.hbox = gtk_hbox_new(FALSE, 0);
    gtk_widget_set_usize(main_win.progress, 100, -1);
    /* add hbox to vbox*/
    gtk_box_pack_start(GTK_BOX(main_win.vbox), main_win.hbox, FALSE, TRUE,0);    

    /* add progress and status to hbox */
    gtk_box_pack_start(GTK_BOX(main_win.hbox), main_win.progress, FALSE, TRUE,0);    
    gtk_box_pack_start(GTK_BOX(main_win.hbox), main_win.statusbar, TRUE, TRUE,0);    


    /* add the accelgroup to the window */
      gtk_window_add_accel_group (GTK_WINDOW (main_win.window), main_win.accel_group);
    
    g_signal_connect(G_OBJECT(main_win.window), "destroy", G_CALLBACK(quit_program), NULL);
    g_signal_connect(G_OBJECT(main_win.window), "configure_event", G_CALLBACK(window_configure_event), NULL);

    /* show all widget recursivly*/
    gtk_widget_show_all(main_win.window);
}


void pref_screen(){
    windows *pref_win;
    int i;
    GtkWidget *ali; /*alignment widget */
    pref_win = g_malloc(sizeof(windows));
    pref_win->window = gtk_window_new(GTK_WINDOW_TOPLEVEL);   
    gtk_window_set_modal(GTK_WINDOW(pref_win->window), TRUE);
    gtk_window_set_title(GTK_WINDOW(pref_win->window), "Inventory (preferences)");
    gtk_container_set_border_width(GTK_CONTAINER(pref_win->window), 6);
    pref_win->vbox = gtk_vbox_new(FALSE,6);
    gtk_container_add(GTK_CONTAINER(pref_win->window), pref_win->vbox);
    
    pref_win->notebook = gtk_notebook_new();
    gtk_box_pack_start(GTK_BOX(pref_win->vbox), pref_win->notebook, TRUE, TRUE,0);
    /* server tab */
    pref_win->server.vbox = gtk_vbox_new(FALSE, 6);
    pref_win->server.label = gtk_label_new("Enter the information required to connect to MySql server");    
    gtk_box_pack_start(GTK_BOX(pref_win->server.vbox), pref_win->server.label, FALSE, TRUE, 0);
    pref_win->server.vbox = gtk_vbox_new(FALSE, 0);
    pref_win->server.tlabel = gtk_label_new_with_mnemonic("_Server");
    pref_win->server.table = gtk_table_new(3,4,FALSE);
    gtk_table_set_row_spacings(GTK_TABLE(pref_win->server.table), 6);
    gtk_table_set_col_spacings(GTK_TABLE(pref_win->server.table), 6);
    pref_win->server.entries = g_malloc(5 * sizeof(GtkWidget));
    pref_win->server.entries[0] = gtk_entry_new(); /* hostname */
    pref_win->server.entries[1] = gtk_entry_new(); /* username */
    pref_win->server.entries[2] = gtk_entry_new(); /* password */
    gtk_entry_set_visibility(GTK_ENTRY(pref_win->server.entries[2]), FALSE);
    gtk_entry_set_invisible_char(GTK_ENTRY(pref_win->server.entries[2]), '*');
    pref_win->server.entries[3] = gtk_entry_new(); /* databse  */
    pref_win->server.entries[4] = NULL;
    
    
    pref_win->server.labels = g_malloc(5 * sizeof(GtkWidget));
    pref_win->server.labels[0] = gtk_label_new("Hostname:");
    pref_win->server.labels[1] = gtk_label_new("Username:");    
    pref_win->server.labels[2] = gtk_label_new("Password:");
    pref_win->server.labels[3] = gtk_label_new("Database:");
    pref_win->server.labels[4] = NULL;
    for(i=0;i<4;i++){
	ali = gtk_alignment_new(1,0,0,0);
	gtk_container_add(GTK_CONTAINER(ali), pref_win->server.labels[i]);
	gtk_table_attach(GTK_TABLE(pref_win->server.table), ali, 0,1,i,i+1,GTK_FILL,GTK_FILL,0,0);
	gtk_table_attach(GTK_TABLE(pref_win->server.table), pref_win->server.entries[i], 1,2,i,i+1,GTK_FILL,GTK_FILL,0,0);
    }
    gtk_container_set_border_width(GTK_CONTAINER(pref_win->server.vbox), 6);
    gtk_box_pack_start(GTK_BOX(pref_win->server.vbox), pref_win->server.table, TRUE, TRUE, 0);
    
    /* make buttons */
    pref_win->server.buttons = g_malloc(3 * sizeof(GtkWidget));
    pref_win->server.buttons[0] = gtk_check_button_new_with_label("Auto Connect");
    pref_win->server.buttons[1] = gtk_check_button_new_with_label("Save Settings");
    pref_win->server.buttons[2] = gtk_check_button_new_with_label("Save Position and Size");    

    gtk_box_pack_start(GTK_BOX(pref_win->server.vbox), pref_win->server.buttons[0], TRUE, TRUE, 0);    
    gtk_box_pack_start(GTK_BOX(pref_win->server.vbox), pref_win->server.buttons[1], TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(pref_win->server.vbox), pref_win->server.buttons[2], TRUE, TRUE, 0);
    gtk_notebook_append_page(GTK_NOTEBOOK(pref_win->notebook), pref_win->server.vbox, pref_win->server.tlabel);
    /* tab done */
    
    /* fill in some info */
    gtk_entry_set_text(GTK_ENTRY(pref_win->server.entries[0]), main_info.hostname);
    gtk_entry_set_text(GTK_ENTRY(pref_win->server.entries[1]), main_info.username);    
    gtk_entry_set_text(GTK_ENTRY(pref_win->server.entries[2]), main_info.password);    
    gtk_entry_set_text(GTK_ENTRY(pref_win->server.entries[3]), main_info.database);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pref_win->server.buttons[0]), main_info.auto_connect);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pref_win->server.buttons[1]), main_info.save_settings);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pref_win->server.buttons[2]), main_info.save_posize);
    /* close button? */
    pref_win->button = gtk_button_new_from_stock(GTK_STOCK_CLOSE);
    ali = gtk_alignment_new(1,0,0,0);
    gtk_container_add(GTK_CONTAINER(ali), pref_win->button);
    gtk_box_pack_start(GTK_BOX(pref_win->vbox), ali, FALSE, TRUE, 0);
    
    /* signals */
    g_signal_connect(G_OBJECT(pref_win->button), "clicked", G_CALLBACK(close_prefwin), pref_win);
    /* FIXME , memory leak now*/

    gtk_widget_show_all(pref_win->window);
}


void about_box(){
    GtkWidget *dialog, *label, *image;
    
    dialog = gtk_dialog_new_with_buttons("About Inventory", GTK_WINDOW(main_win.window), 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
    		GTK_STOCK_OK, GTK_RESPONSE_OK,
		NULL);
    gtk_widget_set_usize(dialog, 300, -1);
    image = gtk_image_new_from_pixbuf(gtk_window_get_icon(GTK_WINDOW(main_win.window)));
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), image, FALSE, FALSE, 6);    
    
    label = gtk_label_new("");
    gtk_label_set_markup(GTK_LABEL(label), "<span weight=\"bold\" size=\"xx-large\">Inventory 0.65</span>");
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, FALSE, FALSE, 6);

    label = gtk_label_new("");
    gtk_label_set_markup(GTK_LABEL(label), "<span size=\"large\">A GTK+-2.0 inventory program</span>");
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, FALSE, FALSE, 12);

    label = gtk_label_new("");
    gtk_label_set_selectable(GTK_LABEL(label), TRUE);
    gtk_label_set_markup(GTK_LABEL(label), "<span size=\"large\" color=\"blue\"><u>http://qball.no-ip.com/test/</u></span>");
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, FALSE, FALSE, 12);

    label = gtk_label_new("");
    gtk_label_set_markup(GTK_LABEL(label), "<i>Written by:</i>");
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, FALSE, FALSE, 3);

    label = gtk_label_new("");
    gtk_label_set_markup(GTK_LABEL(label),"<b>Qball</b> <i>Qball@Qball.homelinux.org</i>");
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, FALSE, FALSE, 3);
    label = gtk_label_new("");
    gtk_label_set_markup(GTK_LABEL(label),"<b>Mike</b> <i>inventory@logan.org</i>");
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, FALSE, FALSE, 3);

    gtk_container_set_border_width(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), 12);
    gtk_widget_show_all(GTK_DIALOG(dialog)->vbox);
    gtk_dialog_run(GTK_DIALOG(dialog));

    gtk_widget_destroy(dialog);
}
