#include <gtk/gtk.h>
#include <mysql/mysql.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "main.h"

int preview_update(GtkWidget *button, windows *import);
int add_cvs_to_table(windows *import);


void import_cvs(const char *name){
    GtkWidget *label;
    GtkWidget *len1, *len2;
    GtkWidget *hbox;
    GtkWidget *blt, *blf, *button;
    windows *import = g_malloc(sizeof(windows));
     int i;
    GtkCellRenderer *renderer;
    import->name = g_strdup(name);
    
    import->dialog = gtk_dialog_new_with_buttons("Import CSV File into current table", GTK_WINDOW(main_win.window), 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
    		GTK_STOCK_OK, GTK_RESPONSE_ACCEPT,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);

    gtk_window_resize(GTK_WINDOW(import->dialog), 480,480);    
    label = gtk_label_new("Import CVS File into current table");
    gtk_label_set_markup(GTK_LABEL(label), "<span weight=\"bold\" size=\"x-large\"> Import CVS File into current table</span>");
    
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(import->dialog)->vbox), label, FALSE, TRUE, 6);
    
    import->entry = g_malloc(4*sizeof(GtkWidget));
    len1 = gtk_label_new("Value Seperator:");
    len2 = gtk_label_new("String Delimiter:");
    import->entry[0] = gtk_entry_new_with_max_length(1);
    import->entry[1] = gtk_entry_new_with_max_length(1);
    
    hbox = gtk_hbox_new(FALSE, 3);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(import->dialog)->vbox), hbox, FALSE, TRUE, 6);
    gtk_box_pack_start(GTK_BOX(hbox), len1, FALSE, TRUE, 6);
    gtk_box_pack_start(GTK_BOX(hbox), import->entry[0], FALSE, TRUE, 6);    
    gtk_box_pack_start(GTK_BOX(hbox), len2, FALSE, TRUE, 6);

    gtk_box_pack_start(GTK_BOX(hbox), import->entry[1], FALSE, TRUE, 6);
    gtk_entry_set_text(GTK_ENTRY(import->entry[0]), ",");
    gtk_entry_set_text(GTK_ENTRY(import->entry[1]), "\"");
    
    hbox = gtk_hbox_new(FALSE, 3);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(import->dialog)->vbox), hbox, FALSE, TRUE, 6);
    blt  = gtk_label_new("Boolean True:");
    blf = gtk_label_new("Boolean False:");
    import->entry[2] = gtk_entry_new_with_max_length(12);
    import->entry[3] = gtk_entry_new_with_max_length(12);
    gtk_box_pack_start(GTK_BOX(hbox), blt, FALSE, TRUE, 6);
    gtk_box_pack_start(GTK_BOX(hbox), import->entry[2], FALSE, TRUE, 6);    
    gtk_box_pack_start(GTK_BOX(hbox), blf, FALSE, TRUE, 6);
    gtk_box_pack_start(GTK_BOX(hbox), import->entry[3], FALSE, TRUE, 6);
    gtk_entry_set_text(GTK_ENTRY(import->entry[2]), "TRUE");
    gtk_entry_set_text(GTK_ENTRY(import->entry[3]), "FALSE");
    
    button = gtk_button_new_with_label("Preview");
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(import->dialog)->vbox), button, FALSE,TRUE, 0);
    g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(preview_update), import);    
    
    import->table.viewport = gtk_scrolled_window_new(NULL, NULL);
    import->table.liststore = gtk_list_store_newv(ncol,main_win.table.types);
    import->table.model = GTK_TREE_MODEL(import->table.liststore);
    import->table.treeview = gtk_tree_view_new_with_model(import->table.model);
    gtk_container_add(GTK_CONTAINER(import->table.viewport), import->table.treeview);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(import->dialog)->vbox), import->table.viewport, TRUE, TRUE, 6);

    for(i=1; i< ncol; i++){
    GtkTreeViewColumn *column;
    	     if(main_win.table.types[i] == G_TYPE_STRING){
		    	renderer = gtk_cell_renderer_text_new();     
		    	column = gtk_tree_view_column_new_with_attributes(gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[i])), renderer, "text",i, NULL);
			 }
	     else if(main_win.table.types[i] == G_TYPE_INT){
		    	renderer = gtk_cell_renderer_text_new();     
		    	column =gtk_tree_view_column_new_with_attributes(gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[i])), renderer, "text",i, NULL);
			 }
		
    	     else{
	      		renderer = gtk_cell_renderer_toggle_new(); 
		        column =gtk_tree_view_column_new_with_attributes(gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[i])), renderer, "active",i, NULL);
		        }  
	gtk_tree_view_append_column(GTK_TREE_VIEW(import->table.treeview), column);

    
    }


    gtk_widget_show_all(GTK_DIALOG(import->dialog)->vbox);
    
    
    
    switch(gtk_dialog_run(GTK_DIALOG(import->dialog))){
    case GTK_RESPONSE_ACCEPT:
	add_cvs_to_table(import);
	break;
    default: break;
    }


    gtk_widget_destroy(import->dialog);
    g_free(import->entry);
    g_free(import->name);
    g_free(import);
    
}




void import_file_selector(){
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    GtkTreeModel *model = GTK_TREE_MODEL(main_win.index.liststore);
    GtkWidget *fileselector;
    GtkWidget *option_menu, *menu_shell, *hbox, *ali;
    int value, close =0;
    char *tempstr;
    /* for now*/
//    error_dialog("Sorry not yet implemented");
//    return;
    
    /* check if there is a valid table to import */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));
    if(!gtk_tree_selection_get_selected(selection, &model, &iter))
	{
	    error_dialog("You need to select a sub-category before you can import items into it");
	    return;
	}
    gtk_tree_model_get(model, &iter,1, &value, -1);
    if(value != 1)
	{
	    error_dialog("You need to select a sub-category before you can import it");
	    return;
	}

    fileselector = gtk_file_selection_new("import from ...");
    tempstr = g_strdup_printf("%s/", g_getenv("HOME"));
    gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselector),tempstr);
    g_free(tempstr);
    
    /* make type selector */
    option_menu = gtk_option_menu_new();
    menu_shell = gtk_menu_new();
    gtk_option_menu_set_menu(GTK_OPTION_MENU(option_menu), menu_shell);
    gtk_menu_shell_append (GTK_MENU_SHELL (menu_shell), gtk_menu_item_new_with_label("Comma Seperated File"));  
//    gtk_menu_shell_append (GTK_MENU_SHELL (menu_shell), gtk_menu_item_new_with_label("HTML"));      
    gtk_option_menu_set_history(GTK_OPTION_MENU(option_menu), 0);
    
    hbox = gtk_hbox_new(FALSE, 6);
    ali = gtk_alignment_new(1, 0.5, 0.5,0.5);
    gtk_container_add(GTK_CONTAINER(ali), gtk_label_new("File Type:"));
    
    gtk_box_pack_start(GTK_BOX(GTK_FILE_SELECTION(fileselector)->main_vbox), hbox, FALSE, TRUE, 6);
    gtk_box_pack_end(GTK_BOX(hbox), option_menu, FALSE, TRUE, 6);
    gtk_box_pack_end(GTK_BOX(hbox), ali, FALSE, TRUE, 6);

    gtk_widget_show_all(hbox);
    
    
    while(!close){
	switch(gtk_dialog_run(GTK_DIALOG(fileselector))){
	case GTK_RESPONSE_OK:
	    /* check if selected file is a directory */
	    if(g_file_test(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselector)), G_FILE_TEST_IS_DIR))
		{
		const gchar *string = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselector));
		gchar *result = g_strconcat(string, "/", NULL);
		gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselector),result);
		g_free(result);
		close = 0;		
		break;
		}
	    if(!g_file_test(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselector)), G_FILE_TEST_EXISTS))
		{
		error_dialog("The file doesn't exist");
		close = 0;
		break;
		}
		value = gtk_option_menu_get_history(GTK_OPTION_MENU(option_menu));
		    if(value == 0){
			import_cvs(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselector)));
			close = 1;
			}
		    else close = 0;	    
		break;
	case GTK_RESPONSE_CANCEL:
	    close = 1;
	default:
	    close = 1;
	    break;
	}
    }	
    gtk_widget_destroy(fileselector);
}    



int preview_update(GtkWidget *button, windows *import){
    GIOChannel *gchan;
    GError *gerror = NULL;
    GString *string;
    gsize test;
    GtkTreeIter iter;
    const gchar *sep = gtk_entry_get_text(GTK_ENTRY(import->entry[0]));
    const gchar *strd = gtk_entry_get_text(GTK_ENTRY(import->entry[1]));
    int rows = 0;
    
    
    gtk_list_store_clear(import->table.liststore);
    
    if(strlen(sep) == 0) return 0;
    gchan = g_io_channel_new_file(import->name, "r", &gerror);
    
    if(gchan == NULL){
	error_dialog(gerror->message);
	return 0;
    }
    
    
    string = g_string_new("");
    switch(g_io_channel_read_line_string(gchan, string, &test, &gerror)){
    case G_IO_STATUS_NORMAL:
	break;
    case G_IO_STATUS_EOF:
	error_dialog("File is empty");
	g_io_channel_shutdown(gchan, TRUE, &gerror);
	g_string_free(string, TRUE);
	return 0;
    case G_IO_STATUS_ERROR:
	error_dialog(gerror->message);
	g_io_channel_shutdown(gchan, TRUE, &gerror);
	g_string_free(string, TRUE);
	return 0;
    default:
	g_io_channel_shutdown(gchan, TRUE, &gerror);
	g_string_free(string, TRUE);
	return 0;
    }
    do{	
    int i, j, cols=0;
    GString *query = g_string_new("");
    gchar **tokens;
    tokens = g_malloc(1*sizeof(gchar));
    tokens[0]= NULL;

    for(i=0; i < string->len; i++)
    {
    if(strlen(strd) == 0){
	j=i;
	for(;i < string->len && string->str[i] != sep[0] && string->str[i] != '\n' && string->str[i] != '\0'; i++);
	if(i != (string->len)){
	    tokens = g_realloc(tokens, (cols+2)*sizeof(gchar *));
	    tokens[cols] = g_strndup(&string->str[j], (i-j));
	    tokens[cols+1] = NULL;
	    cols++;
	    }
	}
    else if(string->str[i] == strd[0]){
	i++;
		
	for(j=0; string->str[i] != strd[0] && i != string->len;j++) i++;
	    tokens = g_realloc(tokens,(cols+2)*sizeof(gchar *));
	    tokens[cols] = g_strndup(&string->str[i-j], (j));
	    tokens[cols+1] = NULL;
	for(;i< string->len && string->str[i] != sep[0] && string->str[i] != '\n'; i++);
	cols++;
        }
    
    }

    /* add it in the test table */
    if(tokens[0] != NULL && cols != 0) gtk_list_store_append(import->table.liststore, &iter);
    for(j=1; j<(ncol) && tokens[j-1] != NULL && cols != 0;j++){	
    if(main_win.table.types[j] == G_TYPE_STRING) gtk_list_store_set(import->table.liststore, &iter, j, tokens[j-1], -1);
    else if(main_win.table.types[j] == G_TYPE_INT)    gtk_list_store_set(import->table.liststore, &iter, j, atoi(tokens[j-1]), -1);
    else if(main_win.table.types[j] == G_TYPE_BOOLEAN){
	if(!strcasecmp(tokens[j-1], gtk_entry_get_text(GTK_ENTRY(import->entry[2]))))
	    {
	    gtk_list_store_set(import->table.liststore, &iter, j, 1, -1);
    	    }
	else{
	    gtk_list_store_set(import->table.liststore, &iter, j, 0, -1);
	    }
	
	}
    }
    
    
    /* end */
       
	g_string_free(query, TRUE);
	g_strfreev(tokens);
	rows++;
	}while(g_io_channel_read_line_string(gchan, string, &test, &gerror) == G_IO_STATUS_NORMAL && rows < 12);

    g_io_channel_shutdown(gchan, TRUE, &gerror);
    g_string_free(string, TRUE);
    return 1;
}


int add_cvs_to_table(windows *import){

    GIOChannel *gchan;
    GError *gerror = NULL;
    GString *string;
    gsize test;
    const gchar *sep = gtk_entry_get_text(GTK_ENTRY(import->entry[0]));
    const gchar *strd = gtk_entry_get_text(GTK_ENTRY(import->entry[1]));
    GtkTreeSelection *selection;
    int rows = 0;
    
    
    gtk_list_store_clear(import->table.liststore);
    
    if(strlen(sep) == 0) return 0;
    gchan = g_io_channel_new_file(import->name, "r", &gerror);
    
    if(gchan == NULL){
	error_dialog(gerror->message);
	return 0;
    }
    
    
    string = g_string_new("");
    switch(g_io_channel_read_line_string(gchan, string, &test, &gerror)){
    case G_IO_STATUS_NORMAL:
	break;
    case G_IO_STATUS_EOF:
	error_dialog("File is empty");
	g_io_channel_shutdown(gchan, TRUE, &gerror);
	g_string_free(string, TRUE);
	return 0;
    case G_IO_STATUS_ERROR:
	error_dialog(gerror->message);
	g_io_channel_shutdown(gchan, TRUE, &gerror);
	g_string_free(string, TRUE);
	return 0;
    default:
	g_io_channel_shutdown(gchan, TRUE, &gerror);
	g_string_free(string, TRUE);
	return 0;
    }
    do{	
    int i, j, cols=0;
    GString *query = g_string_new("");
    gchar **tokens;
    gchar *tname;
    GtkTreeIter iter;
    GtkTreeModel *model = GTK_TREE_MODEL(main_win.index.treestore);

    tokens = g_malloc(1*sizeof(gchar));
    tokens[0]= NULL;

    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    gtk_tree_selection_get_selected(selection, &model, &iter); 
    gtk_tree_model_get(model, &iter, 0, &tname,  -1);


    for(i=0; i < string->len; i++)
    {
    if(strlen(strd) == 0){
	j=i;
	for(;i < string->len && string->str[i] != sep[0] && string->str[i] != '\n' && string->str[i] != '\0'; i++);
	if(i != string->len){
	    tokens = g_realloc(tokens, (cols+2)*sizeof(gchar *));
	    tokens[cols] = g_strndup(&string->str[j], (i-j));
	    tokens[cols+1] = NULL;
	    cols++;
	    }
	}
    else if(string->str[i] == strd[0]){
	i++;
	
	for(j=0; string->str[i] != strd[0] && i != string->len ;j++) i++;
	    tokens = g_realloc(tokens,(cols+2)*sizeof(gchar *));
	    tokens[cols] = g_strndup(&string->str[i-j], (j));
	    tokens[cols+1] = NULL;
	for(;i< string->len && string->str[i] != sep[0] && string->str[i] != '\n'; i++);
	cols++;
        }
    
    }

      

    
    g_string_printf (query, "INSERT INTO `%s` VALUES (''", tname);
    for(i=0;i< ncol-1;i++)
        {
    	if(tokens[i] != NULL) g_string_append_printf(query, ", \"%s\"", g_strescape(tokens[i], ""));
	else  g_string_append_printf(query, ", ''");
        } 
	g_string_append(query, ")");
    /* add it to mysql */
	if(mysql_query(mysql_handle, query->str)){
		    error_dialog(mysql_error(mysql_handle));
/*		    g_string_free(query, TRUE);
		    g_string_free(string, TRUE);
		    g_io_channel_shutdown(gchan, TRUE, &gerror);
		    return 1;
*/	}	

    
    /* end */
       
	g_string_free(query, TRUE);
	g_strfreev(tokens);
	rows++;
	}while(g_io_channel_read_line_string(gchan, string, &test, &gerror) == G_IO_STATUS_NORMAL && rows < 12);

    g_io_channel_shutdown(gchan, TRUE, &gerror);
    g_string_free(string, TRUE);
    index_changed_test(selection);
    return 1;
}
